#ifndef ANIMATION_H
#define ANIMATION_H

#include "Frame.h"
#include <vector>

class Model;

class Animation {

private:
    std::vector<Frame*> frames;
    
    int currentFrame;
    int numFrames;
    float currentFrameTimeLeft;
    
    bool repeat;
    bool stopGraceful;
    bool active;
    
    Model* target;
    
    void setModelToFrame(int i);
    void interpolateModelToFrame(float deltaTime, float timeLeft);
    

public:
    Animation(Model* target, bool repeat);
    
    void addFrame(Frame* frame);
    int getNumFrames();
   
    bool isActive();
    
    void reset();
    void stopGracefully();
    void animate(float deltaTime);
};

#endif
