#ifndef _ENEMY_H_
#define _ENEMY_H_

#include "Object.h"
#include "Wizard.h"
#include "MeltingModelParticleSystem.h"
#include <string>

class Room;

class Enemy : public Object {
    
protected:

    Wizard* wizard;
    Room* room;
    int health;
    int maxHealth;
    
    bool calculateOrientation();
    
    int lastAttackTime;
    int enemyId;
    
    static int idCounter;
    
    int level;
    MeltingModelParticleSystem* melter;
    bool dead;
    
    int lastSprayTime;
    
public:

    Enemy(Detector* detector, Wizard* wizard, Room* room, int level, std::string model, std::string texture);
    ~Enemy();
    void idle(float deltaTime);
    void draw();
    
    virtual void moveForward(float deltaTime) = 0;
    virtual void stop() = 0;
    void attack(Wizard* wizard);

    void changeHealth(int amount);
    bool isAlive();
    bool isDeathAnimationDone();
    
    int getId() { return enemyId; }
    
    void spray(int strength);

};

#endif //_ENEMY_H_
