#ifndef FIREBALL_H
#define FIREBALL_H

#include "Spell.h"
#include "FireballParticleSystem.h"
class Wizard;

class Fireball : public Spell {
    
private:
    FireballParticleSystem* particles;
    Wizard* wizard;
    bool marked;
    float strength;

    void computeStrength(float deltaTime);

public:

    Fireball(Detector* detector, int power, Wizard* wizard);
    ~Fireball();
    void idle(float deltaTime);
    void draw();

    void getBoundingVolume(float *minX,float *maxX,
                       float *minY,float *maxY,
                       float *minZ,float *maxZ);
                       
    void markForDeletion(bool explode);
    bool isMarked();

    int getStrength();

};

#endif
