#ifndef _LEVEL_H_
#define _LEVEL_H_

#include <list>
#include "Detector.h"
#include "Wizard.h"
#include "Wall.h"
#include "Beast.h"
#include "Room.h"
#include "Floor.h"

class Level {
    
private:

    std::list<Wall*> walls;
    std::list<Beast*> beasts;
    std::list<Room*> rooms;
    Detector* detector;
    Wizard* wizard;
    Floor* floor;
    int currLevel;
    bool switchLevel;
    
    void loadLevel1();
    void loadLevel2();
    void loadLevel3();
    void nextLevelReal();
    
public:

    Level(Detector* detector, Wizard* wizard);
    void draw();
    void drawForPick();
    void idle(float deltaTime);
    void nextLevel();

};

#endif //_LEVEL_H_
