#ifndef LINE_PARTICLE_H
#define LINE_PARTICLE_H

#include "Particle.h"

/*
 * Particle that consists of a colored line
 * TODO: parameterize it more
 */
class LineParticle : public Particle {
  private:
    GLfloat color[4];
    float lifetime;
        
  public:
    LineParticle(float lifetime, GLfloat r, GLfloat g, GLfloat b, GLfloat a);
    LineParticle(float lifetime, GLfloat x, GLfloat y, GLfloat z, GLfloat r, GLfloat g, GLfloat b, GLfloat a);
    
    virtual void draw();
    virtual void idle(float deltaTime);
    
    GLfloat* getColor() { return color; }
    GLfloat getColorR() { return color[0]; }
    GLfloat getColorG() { return color[1]; }
    GLfloat getColorB() { return color[2]; }
    GLfloat getColorA() { return color[3]; }         
    
    void setColorR(GLfloat r) { color[0] = r; };   
    void setColorG(GLfloat g) { color[1] = g; };
    void setColorB(GLfloat b) { color[2] = b; };
    void setColorA(GLfloat a) { color[3] = a; };            
    
    float getLifetime() { return lifetime; };
    void setLifetime(float lifetime) { this->lifetime = lifetime; }
    
};

#endif
