#ifndef PARTICLE_SYSTEM_H
#define PARTICLE_SYSTEM_H

#include "Particle.h"

/*
 * Abstract Particle System, subclasses must implement abstract idle method
 * to provide behaviour for the system
 */
class ParticleSystem {
  protected:
    int numParticles;
    Particle** particles;
    bool active;
  public:   
    ParticleSystem(int numParticles);
    ~ParticleSystem();
    
    bool isActive() { return active; }
    void setActive(bool active) { this->active = active; }
    
    virtual void draw();
    virtual void idle(float deltaTime) = 0;
};

#endif
