#ifndef _SPIDER_H_
#define _SPIDER_H_

#include "Enemy.h"
#include "Level.h"

#define SPIDER_REST 30001
#define SPIDER_WALK 30002

class Spider : public Enemy {
    
private:
    
    Frame* frame0;
    Frame* frame1;
    Frame* frame2;
    Animation* walkAnimation;
    Animation* idleAnimation;
    
    Level* lev;
    
public:

    Spider(Detector* detector, Wizard* wizard, Room* room, int level, Level* lev);
    ~Spider();
    
    void moveForward(float deltaTime);
    void stop();

};

#endif //_SPIDER_H_
