#include "WallModel.h"
#include "Utils.h"

WallModel::WallModel(int wall_type) : Model() {
    if (wall_type == BRICK_WALL) {
        Utils::loadTexture("Textures/wall.tga", &textureId, GL_TEXTURE_2D, false);
    } else if (wall_type == WOOD_WALL) {
        Utils::loadTexture("Textures/woodwall.tga", &textureId, GL_TEXTURE_2D, false);
    } else if (wall_type == WHITE_WALL) {
        Utils::loadTexture("Textures/whitebrick.tga", &textureId, GL_TEXTURE_2D, false);
    }
}

void WallModel::draw() {
    
    glColor3f(1,1,1);
    glPushMatrix();
    glBindTexture(GL_TEXTURE_2D, textureId);
    glBegin(GL_QUADS);

        glNormal3f(0,0,1);
        glTexCoord2f(0,0);
        glVertex3f(-length/2.,0,0.25);
        glTexCoord2f(length/2,0);
        glVertex3f(length/2.,0,0.25);        
        glTexCoord2f(length/2,1);
        glVertex3f(length/2.,2,0.25);
        glTexCoord2f(0,1);
        glVertex3f(-length/2.,2,0.25);
    
        glNormal3f(0,0,-1);
        glTexCoord2f(0,0);
        glVertex3f(length/2.,0,-0.25);
        glTexCoord2f(length/2,0);
        glVertex3f(-length/2.,0,-0.25);
        glTexCoord2f(length/2,1);
        glVertex3f(-length/2.,2,-0.25);
        glTexCoord2f(0,1);
        glVertex3f(length/2.,2,-0.25);
        
        glNormal3f(1,0,0);
        glTexCoord2f(0,0);
        glVertex3f(length/2.,0,0.25);
        glTexCoord2f(0.25,0);
        glVertex3f(length/2.,0,-0.25);
        glTexCoord2f(0.25,1);
        glVertex3f(length/2.,2,-0.25);
        glTexCoord2f(0,1);
        glVertex3f(length/2.,2,0.25);
        
        glNormal3f(-1,0,0);
        glTexCoord2f(0,0);
        glVertex3f(-length/2.,0,-0.25);
        glTexCoord2f(0.25,0);
        glVertex3f(-length/2.,0,0.25);
        glTexCoord2f(0.25,1);
        glVertex3f(-length/2.,2,0.25);
        glTexCoord2f(0,1);
        glVertex3f(-length/2.,2,-0.25);
        
        glNormal3f(0,1,0);
        glTexCoord2f(0,0);
        glVertex3f(-length/2.,2,0.25);
        glTexCoord2f(0,0);
        glVertex3f(length/2.,2,0.25);
        glTexCoord2f(0,0);
        glVertex3f(length/2.,2,-0.25);
        glTexCoord2f(0,0);
        glVertex3f(-length/2.,2,-0.25);
        glTexCoord2f(0,0);
        
        glNormal3f(0,-1,0);
        glTexCoord2f(0,0);
        glVertex3f(length/2.,0,0.25);
        glTexCoord2f(0,0);
        glVertex3f(-length/2.,0,0.25);
        glTexCoord2f(0,0);
        glVertex3f(-length/2.,0,-0.25);
        glTexCoord2f(0,0);
        glVertex3f(length/2.,0,-0.25);
    glEnd();
    glPopMatrix();
}

void WallModel::setScale(float length) {
    this->length = length;
}

void WallModel::getBoundingVolume(float *minX,float *maxX,
                                  float *minY,float *maxY,
                                  float *minZ,float *maxZ) {
    *minX = -length/2.;
    *maxX = length/2.;
    *minY = 0;
    *maxY = 2;
    *minZ = -0.25;
    *maxZ = 0.25;
    
}
